#!/usr/bin/perl

############################################################################
##   Copyright (C) 2005 by J Randolph Smith                                #
##   snortsms@servangle.net                                                #
##                                                                         #
##   This program is free software; you can redistribute it and/or modify  #
##   it under the terms of the GNU General Public License as published by  #
##   the Free Software Foundation; either version 2 of the License, or     #
##   (at your option) any later version.                                   #
##                                                                         #
##   This program is distributed in the hope that it will be useful,       #
##   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
##   GNU General Public License for more details.                          #
##                                                                         #
##   You should have received a copy of the GNU General Public License     #
##   along with this program; if not, write to the                         #
##   Free Software Foundation, Inc.,                                       #
##   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################



# Do common initialization and get common routines
# Note this also does the acl acess lookup
require 'snortsms-lib.pl';

#&ReadParseMime();
ReadParse();

# Get prefered interface, or use default.
$snort_int = &Get_Int();

# *** Get the short host name.
$long_host = get_system_hostname();
($myhostname,$crap) = split(/\./,$long_host);

# Send the header
print "Content-type: text/html\n\n";



# ************************************ snort.conf ********************************************
if( $in{'ac'} eq "save_snort")
	{

	# *** Get # of bytes received
	$received = length($in{'content'});

	# *** Generate filename
	$destfile = $in{'path'} . "/SMS_snort." . $in{'int'} . ".conf";

	# *** Write the contents to the file
	&lock_file($destfile);
	$in{'text'} =~ s/\r//g;
	open(FILE, ">$destfile");
	print FILE $in{'content'};
	close(FILE);
	&unlock_file($destfile);

	# *** Get the # of bytes written to the file
	$filesize = -s $destfile;

	# *** Send confirm message
	if ( $filesize == $received )
		{
		# *** Update the MD5 checksum
		$md5_file = $destfile . ".MD5";
		&lock_file($md5_file);
		$in{'text'} =~ s/\r//g;
		open(FILE, ">$md5_file");
		print FILE $in{'MD5'};
		close(FILE);
		&unlock_file($md5_file);

		print"[$myhostname] Push snort config Successful. Saved file $destfile (".$filesize." bytes)\n";
		}
	else
		{ print"[$myhostname] Push snort config FAILED.\n"; }

	
	}
	
	
	

# ************************************ Start Barnyard ********************************************
elsif( $in{'ac'} eq "start_barn")
	{

	$command = $config{'barn_daemon'} . " -D";

	# *** Add switches if they were passed ***
	if($in{'sw_d'} ne "")
		{ $command .= " -d " . $in{'sw_d'}; }
	if($in{'sw_s'} ne "")
		{ $command .= " -s " . $in{'sw_s'}; }
	if($in{'sw_c'} ne "")
		{ $command .= " -c " . $in{'sw_c'}; }
	if($in{'sw_f'} ne "")
		{ $command .= " -f " . $in{'sw_f'}; }
	if($in{'sw_w'} ne "")
		{ $command .= " -w " . $in{'sw_w'}; }
	if($in{'sw_X'} ne "")
		{ $command .= " -X " . $in{'sw_X'}; }

print"Barnyard Start: $command \n";

	}


	
# ************************************ Save barnyard.conf ********************************************
elsif( $in{'ac'} eq "save_barn")
	{
	# *** Get # of bytes received
	$received = length($in{'content'});

	# *** Generate filename
	$destfile = $in{'path'} . "/SMS_barnyard." . $in{'int'} . ".conf";

	# *** Write the contents to the file
	&lock_file($destfile);
	$in{'text'} =~ s/\r//g;
	open(FILE, ">$destfile");
	print FILE $in{'content'};
	close(FILE);
	&unlock_file($destfile);
	
	# *** Get the # of bytes written to the file
	$filesize = -s $destfile;

	# *** Send confirm message
	if ( $filesize == $received )
		{ 
		# *** Update the MD5 checksum
		$md5_file = $destfile . ".MD5";
		&lock_file($md5_file);
		$in{'text'} =~ s/\r//g;
		open(FILE, ">$md5_file");
		print FILE $in{'MD5'};
		close(FILE);
		&unlock_file($md5_file);

		print"[$myhostname] Push barnyard config Successful. Saved file $destfile (".$filesize." bytes)\n"; 
		}
	else
		{ print"[$myhostname] Push barnyard config FAILED.\n"; }
	


	}
	
# ************************************ save sig-msg.map ********************************************
elsif( $in{'ac'} eq "save_sigmsg")
	{
	# *** Get # of bytes received
	$received = length($in{'content'});

	# *** Generate filename
	$destfile = $in{'path'} . "/SMS_sid-msg." .$in{'int'}. ".map";

	# *** Write the contents to the file
	&lock_file($destfile);
	$in{'text'} =~ s/\r//g;
	open(FILE, ">$destfile");
	print FILE $in{'content'};
	close(FILE);
	&unlock_file($destfile);
	
	# *** Get the # of bytes written to the file
	$filesize = -s $destfile;

	# *** Send confirm message
	if ( $filesize == $received )
		{ print"[$myhostname] Push sig-msg.map Successful. Saved file $destfile (".$filesize." bytes)\n"; }
	else
		{ print"[$myhostname] Push sig-msg.map Push: FAILED.\n"; }
	
	}
	
print "_EOF_\n";
	
exit;
