#!/usr/bin/perl

############################################################################
##   Copyright (C) 2005 by J Randolph Smith                                #
##   snortsms@servangle.net                                                #
##                                                                         #
##   This program is free software; you can redistribute it and/or modify  #
##   it under the terms of the GNU General Public License as published by  #
##   the Free Software Foundation; either version 2 of the License, or     #
##   (at your option) any later version.                                   #
##                                                                         #
##   This program is distributed in the hope that it will be useful,       #
##   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
##   GNU General Public License for more details.                          #
##                                                                         #
##   You should have received a copy of the GNU General Public License     #
##   along with this program; if not, write to the                         #
##   Free Software Foundation, Inc.,                                       #
##   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################


# Do common initialization and get common routines
# Note this also does the acl acess lookup
require 'snortsms-lib.pl';

&ReadParseMime();
#&ReadParse();



# *** Get the short host name.
$long_host = get_system_hostname();
($myhostname,$crap) = split(/\./,$long_host);

# Send the header
print "Content-type: text/html\n\n";



# ************************************ snort.conf ********************************************
if( $in{'ac'} eq "save_snort")
	{

	# *** Get # of bytes received
	$received = length($in{'content'});

	# *** Generate filename
	$destfile = $in{'path'} . "/SMS_snort." . $in{'int'} . ".conf";

	# *** Write the contents to the file
	&lock_file($destfile);
	$in{'text'} =~ s/\r//g;
	open(FILE, ">$destfile");
	print FILE $in{'content'};
	close(FILE);
	&unlock_file($destfile);

	# *** Get the # of bytes written to the file
	$filesize = -s $destfile;

	# *** Send confirm message
	if ( $filesize == $received )
		{
		# *** Update the MD5 checksum
		$md5_file = $destfile . ".MD5";
		&lock_file($md5_file);
		$in{'text'} =~ s/\r//g;
		open(FILE, ">$md5_file");
		print FILE $in{'MD5'};
		close(FILE);
		&unlock_file($md5_file);

		print"[$myhostname] Push snort config Successful. Saved file $destfile (".$filesize." bytes)\n";
		}
	else
		{ print"[$myhostname] ERROR: Push snort config FAILED.\n"; }

	
	}
	
# ************************************ Start Snort ********************************************
elsif( $in{'ac'} eq "start_snort")
	{
	$debugfile = &tempname();
	# *** Stage the command lines	
	$command_debug = $config{'snort_daemon'} . " -T -i " . $in{'int'};
	$command_exec = $config{'snort_daemon'} . " -D -i " . $in{'int'};
	# * Add any arguments ***
	$command = " -c " . $in{'path'} . "/SMS_snort." . $in{'int'} . ".conf";
	if($in{'args'} ne "")
		{ $command .= " " . $in{'args'}; }
	# * Finalize commands
	$command_debug .= $command;
	$command_exec .= $command;
	
	# Check if snort is already running
	$pid_file = "/var/run/snort_" . $in{'int'} . ".pid";
	$temp_pid = check_pid_file($pid_file);
	if($temp_pid >= 1)
		{
		print"[$myhostname] ERROR: Snort appears to be already running - PID $temp_pid\n";
		}
	else
		{
		
		# *** Test Snort
		$output_debug = "";
		$result_code = system("/bin/sh -c \"".$command_debug. " > ".$debugfile." 2>&1\"");
		open(DEBUGFILE, $debugfile);
		while(<DEBUGFILE>) 
			{

			$output_debug .= $_;
			}
		close(DEBUGFILE);
		unlink($debugfile);
		
		if (!($output_debug =~ /ERROR/i))	# *** Passed config test
			{
			# *** Save command line
			$destfile = $in{'path'} . "/SMS_snort." . $in{'int'} . ".conf.CMD";
			&lock_file($destfile);
			$command_exec =~ s/\r//g;
			open(FILE, ">$destfile");
			print FILE $command_exec;
			close(FILE);
			&unlock_file($destfile);
	
			# *** Start Snort
			$output = system($command_exec);
			# Wait for snort to settle
			sleep(1);
	
			# *** Check if it's running now
			$temp_pid = check_pid_file($pid_file);
			if($temp_pid >= 1)
				{
				print"[$myhostname] Snort started Successfully - PID $temp_pid\n";
				}
			else
				{
				print"[$myhostname] ERROR: Snort FAILED to start.\n";
				print"[$myhostname] $command_exec\n";
				}
			}
		else	# *** Failed config test
			{
			print"[$myhostname] ERROR: Snort FAILED configuration test.\n";
			print $output_debug;
			}
		

		}

	}



# ************************************ Snort Status ********************************************
elsif( $in{'ac'} eq "snort_status")
	{
	# Check if Snort is running
	$result = &Get_Snort_PID();
	print $result ."\n";cd 
	}

	
# ************************************ Snort info ********************************************
elsif( $in{'ac'} eq "snort_info")
	{
	$debugfile = &tempname();
	$output_debug = "";

	# *** Show the version number and exit 
	$command_exec = $config{'snort_daemon'} . " -V";
	$result_code = system("/bin/sh -c \"".$command_exec. " > ".$debugfile." 2>&1\"");
	open(DEBUGFILE, $debugfile);
	while(<DEBUGFILE>) 
		{
		$output_debug .= $_;
		}
	close(DEBUGFILE);
	unlink($debugfile);
	
	print"[$myhostname]\n";
	print $output_debug;

	}
	
	
# ************************************ Get Snort MD5 ********************************************
elsif( $in{'ac'} eq "snort_MD5")
	{
	$return = &Get_Snort_MD5();
	print $result . "\n";
	}



# ************************************ Stop Snort ********************************************
elsif( $in{'ac'} eq "stop_snort")
	{

	# Check if snort is already running
	$pid_file = "/var/run/snort_" . $in{'int'} . ".pid";
	$temp_pid = check_pid_file($pid_file);
	if($temp_pid >= 1)
		{
		if (&kill_logged("-9", $temp_pid)) 
			{
			sleep(1);
			# Check if it's still running
			$temp_pid = check_pid_file($pid_file);
			if($temp_pid >= 1)
				{
				print"[$myhostname] ERROR: Failed to stop Snort - PID $temp_pid\n";
				}
			else
				{
				print"[$myhostname] Snort successfully stopped.\n";
				}
			}
		else 
			{
			# failed to send signal
			print"[$myhostname] \n";
			&error("$!");
			}
		}
	else
		{
		print"[$myhostname] ERROR: Cannot stop Snort. Snort doesn't appear to be running.\n";
		}

	}

# ************************************ Restart Barnyard ********************************************
elsif( $in{'ac'} eq "reset_snort")
	{

	# Check if snort is already running
	$pid_file = "/var/run/snort_" . $in{'int'} . ".pid";
	$temp_pid = check_pid_file($pid_file);
	if($temp_pid >= 1)
		{
		if (&kill_logged("-HUP", $temp_pid)) 
			{
			sleep(1);
			# Check if it's still running
			$temp_pid = check_pid_file($pid_file);
			if($temp_pid >= 1)
				{
				print"[$myhostname] Snort restarted - PID $temp_pid\n";
				}
			else
				{
				print"[$myhostname] ERROR: Snort died permaturely.\n";
				}
			}
		else 
			{
			# failed to send signal
			print"[$myhostname] \n";
			&error("$!");
			}
		}
	else
		{
		print"[$myhostname] Cannot restart Snort. Snort doesn't appear to be running.\n";
		}

	}




	

# ************************************ Start Barnyard ********************************************
elsif( $in{'ac'} eq "start_barn")
	{
	# Stage the command line
	$command = $config{'barn_daemon'} . " -D";
	$command .= " -c " . $in{'path'} . "/SMS_barnyard." . $in{'int'} . ".conf";

	# *** Add switches if they were passed ***
	if($in{'sw_d'} ne "")
		{ $command .= " -d " . $in{'sw_d'}; }
	if($in{'sw_s'} ne "")
		{ $command .= " -s " . $in{'sw_s'}; }
	if($in{'sw_f'} ne "")
		{ $command .= " -f " . $in{'sw_f'}; }
	if($in{'sw_w'} ne "")
		{ $command .= " -w " . $in{'sw_w'}; }
	if($in{'sw_X'} ne "")
		{ $command .= " -X " . $in{'sw_X'}; }

		
	# *** Save command line
	$destfile = $in{'path'} . "/SMS_barnyard." . $in{'int'} . ".conf.CMD";
	&lock_file($destfile);
	$command =~ s/\r//g;
	open(FILE, ">$destfile");
	print FILE $command;
	close(FILE);
	&unlock_file($destfile);
		
	# Check if barnyard is already running
	$temp_pid = check_pid_file($in{'sw_X'});
	if($temp_pid >= 1)
		{
		print"[$myhostname] ERROR: Barnyard appears to be already running - PID $temp_pid\n";
		}
	else
		{
		$output = system($command);

		# Wait for barnyard to settle
		sleep(1);

		# Check if it's running now
		$temp_pid = check_pid_file($in{'sw_X'});
		if($temp_pid >= 1)
			{
			print"[$myhostname] Barnyard started Successfully - PID $temp_pid\n";
			}
		else
			{
			print"[$myhostname] ERROR: Barnyard FAILED to start.\n";
			}
		}
	}


# ************************************ Barnyard Status ********************************************
elsif( $in{'ac'} eq "barn_status")
	{
	# Check if barnyard is running
	$result = &Get_Barn_PID();
	print $result ."\n";
	}


# ************************************ Barnyard info ********************************************
elsif( $in{'ac'} eq "barn_info")
	{
	$debugfile = &tempname();
	$output_debug = "";

	# *** Show the version number and exit 
	$command_exec = $config{'barn_daemon'} . " -V";
	$result_code = system("/bin/sh -c \"".$command_exec. " > ".$debugfile." 2>&1\"");
	open(DEBUGFILE, $debugfile);
	while(<DEBUGFILE>) 
		{
		$output_debug .= $_;
		}
	close(DEBUGFILE);
	unlink($debugfile);
	
	print"[$myhostname]\n";
	print $output_debug;

	}
	
# ************************************ Get Barnyard MD5 ********************************************
elsif( $in{'ac'} eq "barn_MD5")
	{
	$result = &Get_Barn_MD5();
	print $result . "\n";
	}



# ************************************ Stop Barnyard ********************************************
elsif( $in{'ac'} eq "stop_barn")
	{

	# Check if barnyard is already running
	$temp_pid = check_pid_file($in{'sw_X'});
	if($temp_pid >= 1)
		{
		if (&kill_logged("-9", $temp_pid)) 
			{
			sleep(1);
			# Check if it's still running
			$temp_pid = check_pid_file($in{'sw_X'});
			if($temp_pid >= 1)
				{
				print"[$myhostname] ERROR: Failed to stop Barnyard - PID $temp_pid\n";
				}
			else
				{
				print"[$myhostname] Barnyard successfully stopped.\n";
				}
			}
		else 
			{
			# failed to send signal
			print"[$myhostname] \n";
			&error("$!");
			}
		}
	else
		{
		print"[$myhostname] ERROR: Cannot stop Barnyard. Barnyard doesn't appear to be running.\n";
		}

	}

# ************************************ Restart Barnyard ********************************************
elsif( $in{'ac'} eq "reset_barn")
	{

	# Check if barnyard is already running
	$temp_pid = check_pid_file($in{'sw_X'});
	if($temp_pid >= 1)
		{
		if (&kill_logged("-HUP", $temp_pid)) 
			{
			sleep(1);
			# Check if it's still running
			$temp_pid = check_pid_file($in{'sw_X'});
			if($temp_pid >= 1)
				{
				print"[$myhostname] Barnyard restarted - PID $temp_pid\n";
				}
			else
				{
				print"[$myhostname] ERROR: Barnyard died permaturely.\n";
				}
			}
		else 
			{
			# failed to send signal
			print"[$myhostname] \n";
			&error("$!");
			}
		}
	else
		{
		print"[$myhostname] Cannot restart Barnyard. Barnyard doesn't appear to be running.\n";
		}

	}
	
# ************************************ Save barnyard.conf ********************************************
elsif( $in{'ac'} eq "save_barn")
	{
	# *** Get # of bytes received
	$received = length($in{'content'});

	# *** Generate filename
	$destfile = $in{'path'} . "/SMS_barnyard." . $in{'int'} . ".conf";

	# *** Write the contents to the file
	&lock_file($destfile);
	$in{'text'} =~ s/\r//g;
	open(FILE, ">$destfile");
	print FILE $in{'content'};
	close(FILE);
	&unlock_file($destfile);
	
	# *** Get the # of bytes written to the file
	$filesize = -s $destfile;

	# *** Send confirm message
	if ( $filesize == $received )
		{ 
		# *** Update the MD5 checksum
		$md5_file = $destfile . ".MD5";
		&lock_file($md5_file);
		$in{'text'} =~ s/\r//g;
		open(FILE, ">$md5_file");
		print FILE $in{'MD5'};
		close(FILE);
		&unlock_file($md5_file);

		print"[$myhostname] Push barnyard config Successful. Saved file $destfile (".$filesize." bytes)\n"; 
		}
	else
		{ print"[$myhostname] ERROR: Push barnyard config FAILED.\n"; }
	


	}
	
# ************************************ save sig-msg.map ********************************************
elsif( $in{'ac'} eq "save_sigmsg")
	{
	# *** Get # of bytes received
	$received = length($in{'content'});

	# *** Generate filename
	$destfile = $in{'path'} . "/SMS_sid-msg." .$in{'int'}. ".map";

	# *** Write the contents to the file
	&lock_file($destfile);
	$in{'text'} =~ s/\r//g;
	open(FILE, ">$destfile");
	print FILE $in{'content'};
	close(FILE);
	&unlock_file($destfile);
	
	# *** Get the # of bytes written to the file
	$filesize = -s $destfile;

	# *** Send confirm message
	if ( $filesize == $received )
		{ print"[$myhostname] Push sig-msg.map Successful. Saved file $destfile (".$filesize." bytes)\n"; }
	else
		{ print"[$myhostname] ERROR: Push sig-msg.map Push: FAILED.\n"; }
	
	}
	

# ************************************ Check DB connection ********************************************
elsif( $in{'ac'} eq "check_db")
	{
	$result = &Check_Connection();
	print "$result\n";
	}
	
# ************************************ Check CPU load ********************************************
elsif( $in{'ac'} eq "check_uptime")
	{
	$result = &Get_Sys_Uptime();
	print "[$myhostname] $result\n";
	}
	
# ************************************ Check Drive Usage ********************************************
elsif( $in{'ac'} eq "check_df")
	{	
	$result = &Get_Sys_df();
	print $result . "\n";
	}
	
	

	
# ************************************ Get All stats ********************************************
elsif( $in{'ac'} eq "check_all")
	{
	$output_la = &Get_Sys_Uptime();
	$output_df = &Get_Sys_df();
	$output_db = &Check_Connection();
	$output_snort_pid = &Get_Snort_PID();
	$output_barn_pid = &Get_Barn_PID();
	$output_snot_MD5 = &Get_Snort_MD5();
	$output_barn_MD5 = &Get_Barn_MD5();

	print "LA=" . $output_la;
	print "||";
	print "DF=" . $output_df;
	print "||";
	print "DB=" . $output_db;
	print "||";
	print "SP=" . $output_snort_pid;
	print "||";
	print "BP=" . $output_barn_pid;
	print "||";
	print "S5=" . $output_snot_MD5;
	print "||";
	print "B5=" . $output_barn_MD5;
	}
	
	
#print "\n";
	
exit;

