#!/usr/bin/perl

############################################################################
##   Copyright (C) 2005 by J Randolph Smith                                #
##   snortsms@servangle.net                                                #
##                                                                         #
##   This program is free software; you can redistribute it and/or modify  #
##   it under the terms of the GNU General Public License as published by  #
##   the Free Software Foundation; either version 2 of the License, or     #
##   (at your option) any later version.                                   #
##                                                                         #
##   This program is distributed in the hope that it will be useful,       #
##   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
##   GNU General Public License for more details.                          #
##                                                                         #
##   You should have received a copy of the GNU General Public License     #
##   along with this program; if not, write to the                         #
##   Free Software Foundation, Inc.,                                       #
##   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################


# text_text.cgi
# Display a form for manually editing the Snort config file
# Based on bind8 function in Webmin

require 'snortsms-lib.pl';
&ReadParse();

# Get prefered interface, or use default.
$snort_int = &Get_Int();

$temp_snort_conf = $config{'snort_config'} . "snortsms." . $config{'snort_int'} . ".conf";

&foreign_require("proc", "proc-lib.pl");
@procs = &proc::list_processes();


if ($in{'raw'} eq "1")
	{
	&PrintHeader();
	foreach $proc (@procs)
		{
		print $proc->{"pid"}.",".$proc->{"user"}.",".$proc->{"size"}.",".$proc->{"time"}.",".$proc->{"args"}."\n";
		}
	}
else
	{
	&header($text{'ps_title'}, "");

	print "<HR>\n";
	print "<TABLE border=1>";
	print "<tr><th>PID</th><th>User</th><th>Size</th><th>Time</th><th>Process</th></tr>";

	foreach $proc (@procs)
		{
		print "<tr><td>". $proc->{"pid"}."</td><td>".$proc->{"user"}."</td><td nowrap>".$proc->{"size"}."</td><td>".$proc->{"time"}."</td><td>".$proc->{"args"}."&nbsp;</td></tr>";
		}

	print "</TABLE>";
	print "<HR>\n";
	
	&footer("index.cgi", $text{'back_link'});
	}
