#!/usr/bin/perl
#
# Snort Webmin Module
# 
############################################################################
##   Copyright (C) 2005 by J Randolph Smith                                #
##   snortsms@servangle.net                                                #
##                                                                         #
##   This program is free software; you can redistribute it and/or modify  #
##   it under the terms of the GNU General Public License as published by  #
##   the Free Software Foundation; either version 2 of the License, or     #
##   (at your option) any later version.                                   #
##                                                                         #
##   This program is distributed in the hope that it will be useful,       #
##   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
##   GNU General Public License for more details.                          #
##                                                                         #
##   You should have received a copy of the GNU General Public License     #
##   along with this program; if not, write to the                         #
##   Free Software Foundation, Inc.,                                       #
##   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################



# Do common initialization and get common routines
# Note this also does the acl acess lookup
require 'snortsms-lib.pl';
ReadParse();

# Get prefered interface, or use default.
$snort_int = &Get_Int();



# Lets check and make sure the module was configured with defaults during installation,
# or that settings have been previously saved, otherwise, lets dump them to the config screen
($snort_bin) = $config{'snort_path'} =~ /^(\S+)/;  # Strip any options - note this will choke if there are spaces in path!

#if ((! -r $snort_bin) || (! -r $config{'snort_config'}) ) 
if (! -r $config{'snort_daemon'}) 
	{
	# Check if they can change config first!
	if ($access{'noconfig'}) 
		{
		$whatfailed = $text{'error_confchk'};
		&snort_error($text{'error_config'});
		}
	else 
		{
		&redirect("/config.cgi?snortsms");  # Redirect user to config section
		exit;
		}
	}

# Send the header
&header($text{'index_title'}, "", undef, 1, 1, 0,
&help_search_link("snort", "man", "doc", "google"));



print "<p>INT = $snort_int</p>\n";
print "<hr>\n";

# Display icons for global options
print "<h3>$text{'index_opts'}</h3>\n";
   
push(@olinks, "dsp_sedit.cgi");
push(@olinks, "dsp_sview.cgi");
push(@olinks, "dsp_bedit.cgi");
push(@olinks, "dsp_bview.cgi");

@otitles = map { /dsp_(\S+).cgi/; $text{$1."_title"} } @olinks;
@oicons = map { /^dsp_(\S+).cgi/; "images/$1.gif"; } @olinks;

&icons_table(\@olinks, \@otitles, \@oicons);
print "<hr>\n";








# Lets see if snort is already running or not
$temp_snort_pid_file = $config{'snort_pid'} . "snort_" . $snort_int . ".pid";
if (open(PID, $temp_snort_pid_file)) 
	{
	chop($pid = <PID>);
	close(PID);
	}
if ($pid && kill(0, $pid)) 
	{
	# Snort is running.
	$temp_snort_status = 1;
	$temp_snort_pid = $pid;
	}
else
	{
	# Unable to find PID
	$temp_snort_status = 0;
	}



print "<table border=1><tr><th colspan=2>Sensor Status</th></tr>";
print "<tr><td colspan=2>&nbsp;</td></tr>";
if ($temp_snort_status == 1)
	{
	print "<tr><td style=\"background-color:Green;\">&nbsp;</td><td>Snort is running - PID ".$temp_snort_pid."</td></tr>";
	}
else
	{
	print "<tr><td style=\"background-color:Red;\">&nbsp;</td><td>Snort is not running</td></tr>";
	}
print "";
print "";
print "";
print "";
print "</table>";






# we're done here, just print the footer and quit
&footer("/", $text{"index"});
exit;

