#!/usr/bin/perl

############################################################################
##   Copyright (C) 2005 by J Randolph Smith                                #
##   snortsms@servangle.net                                                #
##                                                                         #
##   This program is free software; you can redistribute it and/or modify  #
##   it under the terms of the GNU General Public License as published by  #
##   the Free Software Foundation; either version 2 of the License, or     #
##   (at your option) any later version.                                   #
##                                                                         #
##   This program is distributed in the hope that it will be useful,       #
##   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
##   GNU General Public License for more details.                          #
##                                                                         #
##   You should have received a copy of the GNU General Public License     #
##   along with this program; if not, write to the                         #
##   Free Software Foundation, Inc.,                                       #
##   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

# snortsms-lib.pl - common routines for the snort Webmin inerface

# Grab common webmin routines and initialize
do '../web-lib.pl';
&init_config("snort");




$conf_file_snort = $config{'snort_conf_dir'} . "/sms_snort.conf";
$conf_file_barn = $config{'barn_conf_dir'} . "/sms_baryard.conf";
$conf_file_sigmsg = $config{'barn_conf_dir'} . "/sid-msg.map";






sub snort_error {
   &header($text{'error'}, "");
   print "<hr>\n<h3>",($whatfailed ? "$whatfailed : " : ""),join(" ", @_),"</h3>\n<hr>\n";
   &footer("index.cgi", $text{'back_link'});
   exit;
}



# Checks if Snort is running
sub Get_Snort_PID
	{
	my($pid_file) = "/var/run/snort_" . $in{'int'} . ".pid";
	my($temp_pid) = check_pid_file($pid_file);
	if($temp_pid >= 1)
		{	$output = "$temp_pid"; }
	else
		{	$output = "-1"; }
		
	return($output);
	}


# Checks if barnyard is running
sub Get_Barn_PID
	{
	my($temp_pid) = check_pid_file($in{'sw_X'});
	if($temp_pid >= 1)
		{	$output = "$temp_pid"; }
	else
		{	$output = "-1"; }
	
	
	return($output);
	}

# Returns the MD5 stored in file
sub Get_Barn_MD5
	{
	my($lines);
	my($destfile) = $in{'path'} . "/SMS_barnyard." . $in{'int'} . ".conf.MD5";
	if($lines = read_file_lines($destfile))
		{ $output = $$lines[0]; }
	else
		{ $output =  "[$myhostname] ERROR: Cannot open $destfile"; }
		
	return($output);
	}

# Returns the MD5 stored in file
sub Get_Snort_MD5
	{
	my($lines);
	my($destfile) = $in{'path'} . "/SMS_snort." . $in{'int'} . ".conf.MD5";
	if($lines = read_file_lines($destfile))
		{ $output = $$lines[0]; }
	else
		{ $output =  "[$myhostname] ERROR: Cannot open $destfile"; }
		
	return($output);
	}

# *** Get uptime
sub Get_Sys_Uptime
	{	
	$output = `uptime`;
	chop($output);
	return($output);
	}

# *** Get 'df -k'
sub Get_Sys_df
	{
	$output = `df -k`;
	return($output);
	}
	
	
# *** Check for a connection listed in 'netstat'
sub Check_Connection
	{
	$output = 0;
	my($proto,$rq,$sq,$local_addr,$foriegn_addr,$state) ;
	my($pattern) = $in{'ip'} . "." . $in{'port'};	
	# *** Get a netstat
	my(@lines) = `netstat -an`;	
	#*** Loop thru and find the connection we want
	foreach (@lines)
		{
		chop;
		($proto,$rq,$sq,$local_addr,$foriegn_addr,$state) = split(/\s+/,$_);	
		if(($foriegn_addr eq $pattern) && ($state eq "ESTABLISHED"))
			{
			# print "MATCH!!! -> $foriegn_addr\n";
			$output = 1;
			}
		}	
	
	return($output);
	}
	
	
	



1;

